import React from 'react';
function external_link(url, label) {
    return (React.createElement("a", { href: url, target: "_blank", rel: "noopener noreferrer", className: "lsp-external-link" }, label));
}
const migration_guide_url = 'https://jupyter-server.readthedocs.io/en/latest/operators/migrate-from-nbserver.html';
const jupyter_hub_migration_url = 'https://github.com/jupyterhub/jupyterhub/pull/3329/files';
export const SERVER_EXTENSION_404 = (React.createElement("div", null,
    React.createElement("p", null,
        "It appears that the required Jupyter server extension (",
        React.createElement("code", null, "jupyter-lsp"),
        ") is not installed (or not enabled) in this environment."),
    React.createElement("h3", null, "What are the likely reasons?"),
    React.createElement("ul", null,
        React.createElement("li", null, "It might be that you just installed it and need to restart JupyterLab to make it available on startup."),
        React.createElement("li", null,
            "Alternatively, you may be using an older ",
            React.createElement("code", null, "notebook"),
            " server instead of the new ",
            React.createElement("code", null, "jupyter_server"),
            "; please refer to the",
            ' ',
            external_link(migration_guide_url, 'migration guide'),
            " or if you are a JupyterHub user please ensure that you start the JupyterLab using",
            ' ',
            React.createElement("code", null, "jupyter_server"),
            " and not the old ",
            React.createElement("code", null, "notebook"),
            ", as documented in",
            ' ',
            external_link(jupyter_hub_migration_url, 'this pull request'),
            "."),
        React.createElement("li", null,
            "There may be schema errors or language server errors preventing the extension from loading - please check the logs of JupyterLab (in the console where you execute ",
            React.createElement("code", null, "jupyter lab"))),
    React.createElement("h3", null, "How do I check if the extension is installed?"),
    React.createElement("p", null,
        "Please ensure that ",
        React.createElement("code", null, "jupyter server extension list"),
        " includes jupyter-lsp and that it is enabled. If it is enabled please try to restart JupyterLab. If the server extension is installed but not enabled and all other suggestions listed above failed try the following:",
        React.createElement("code", null, "jupyter server extension enable --user --py jupyter_lsp"))));
//# sourceMappingURL=errors.js.map