import { JupyterFrontEndPlugin } from '@jupyterlab/application';
import { ILSPCodeExtractorsManager } from '../tokens';
import { IForeignCodeExtractor, IForeignCodeExtractorsRegistry } from './types';
export declare class CodeExtractorsManager implements ILSPCodeExtractorsManager {
    registry: IForeignCodeExtractorsRegistry;
    constructor();
    /**
     * Register an extractor to extract foreign code from host documents of specified language.
     */
    register(extractor: IForeignCodeExtractor, host_language: string): void;
}
export declare const CODE_EXTRACTORS_MANAGER: JupyterFrontEndPlugin<ILSPCodeExtractorsManager>;
