import { ILSPCodeExtractorsManager } from '../tokens';
export class CodeExtractorsManager {
    constructor() {
        this.registry = {};
    }
    /**
     * Register an extractor to extract foreign code from host documents of specified language.
     */
    register(extractor, host_language) {
        if (!this.registry.hasOwnProperty(host_language)) {
            this.registry[host_language] = [];
        }
        this.registry[host_language].push(extractor);
    }
}
export const CODE_EXTRACTORS_MANAGER = {
    id: ILSPCodeExtractorsManager.name,
    requires: [],
    activate: app => {
        return new CodeExtractorsManager();
    },
    provides: ILSPCodeExtractorsManager,
    autoStart: true
};
//# sourceMappingURL=manager.js.map