import { JupyterFrontEndPlugin } from '@jupyterlab/application';
import { LabIcon } from '@jupyterlab/ui-components';
import { CodeJumper } from '@krassowski/code-jumpers';
import { AnyLocation } from 'lsp-ws-connection/lib/types';
import { CodeJump as LSPJumpSettings, ModifierKey } from '../_jump_to';
import { CodeMirrorIntegration } from '../editor_integration/codemirror';
import { FeatureSettings } from '../feature';
export declare const jumpToIcon: LabIcon;
export declare class CMJumpToDefinition extends CodeMirrorIntegration {
    get jumper(): CodeJumper;
    get settings(): FeatureSettings<LSPJumpSettings>;
    protected get modifierKey(): ModifierKey;
    register(): void;
    get_uri_and_range(location_or_locations: AnyLocation): {
        uri: string;
        range: import("vscode-languageserver-types").Range;
    };
    handle_jump(location_or_locations: AnyLocation, document_uri: string): Promise<void>;
}
export declare const JUMP_PLUGIN: JupyterFrontEndPlugin<void>;
