import { JupyterFrontEndPlugin } from '@jupyterlab/application';
import { IEditorMimeTypeService } from '@jupyterlab/codeeditor';
import { CodeMirrorEditor, ICodeMirror } from '@jupyterlab/codemirror';
import { LabIcon } from '@jupyterlab/ui-components';
import { CodeSyntax as LSPSyntaxHighlightingSettings } from '../_syntax_highlighting';
import { CodeMirrorIntegration } from '../editor_integration/codemirror';
import { IEditorIntegrationOptions, IFeatureLabIntegration, IFeatureSettings } from '../feature';
export declare const syntaxHighlightingIcon: LabIcon;
export declare class CMSyntaxHighlighting extends CodeMirrorIntegration {
    editors_with_active_highlight: Set<CodeMirrorEditor>;
    constructor(options: IEditorIntegrationOptions);
    get lab_integration(): SyntaxLabIntegration;
    get settings(): IFeatureSettings<LSPSyntaxHighlightingSettings>;
    private get_mode;
    update_mode(): void;
}
declare class SyntaxLabIntegration implements IFeatureLabIntegration {
    mimeTypeService: IEditorMimeTypeService;
    codeMirror: ICodeMirror;
    settings: IFeatureSettings<LSPSyntaxHighlightingSettings>;
    constructor(mimeTypeService: IEditorMimeTypeService, codeMirror: ICodeMirror);
}
export declare const SYNTAX_HIGHLIGHTING_PLUGIN: JupyterFrontEndPlugin<void>;
export {};
